<?
/**
 * @package NFB_Video_Plugin
 * @author Audrey-Rose Savard
 * @version 0.5.5
 */
/*
Plugin Name: NFB Video Plugin
Plugin URI: http://www.nfb.ca/gadgets/en/
Description: This plugin allows you to take any url from the NFB's film pages and be able to embed it into your post.
Author: Audrey-Rose Savard | National Film Board of Canada
Version: 0.5.5
Author URI: 
*/
/*
  Copyright 2009 National Film Board of Canada (email : )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


include_once('simple_html_dom.php');

global $NFB_OEMBED;

function nfb_get_oembed_links($url){
	//PUT TOGETHER THE FIRST 75 LINES OF THE PAGE TO SIFT THROUGH AFTER
	global $NFB_OEMBED;
	$NFB_FOUND_OEMBED = 0;
	$file_handle = fopen($url, "r");
	$x = 0;
	$html = "";
	while(!feof($file_handle)){
		if ($x == 75){ break; }
		$toadd = fgets($file_handle, 4096);
		if (strstr($toadd, 'json+oembed') || strstr($toadd, 'xml+oembed')){
			$html .= $toadd;
			$NFB_FOUND_OEMBED = 1;
		}
		$x++;
	}
	fclose($file_handle);
	
	//RETRIEVE THE OEMBED LINKS AND PUT THEM IN THE NFB_OEMBED ARRAY

	preg_match_all('/http:\/\/[0-9a-z_.\\w\/\\#~:?+=&;%@!-]*/i', $html, $oembedlinks);
	foreach($oembedlinks[0] as $olink){
		if (strstr($olink, 'xml')){
			$NFB_OEMBED['xml_link'] = $olink;
		}
		elseif (strstr($olink, 'json')){
			$NFB_OEMBED['json_link'] = $olink;
		}
	}
	return $NFB_FOUND_OEMBED;
}

function nfb_get_links(&$text){
	preg_match_all('/\s?http:\/\/[0-9a-z_.\\w\/\\#~:?+=&;%@!-]*/i', $text, $links);
	
	return $links[0];
}

function nfb_get_video_details(){
	global $NFB_OEMBED;
	$xml_file = file_get_html($NFB_OEMBED['xml_link']);
	$NFB_OEMBED['version'] = $xml_file->getElementByTagName('version')->plaintext; //must be 1.0 according to the specification
	$NFB_OEMBED['type'] = $xml_file->getElementByTagName('type')->plaintext; //video/image/etc
	if ($NFB_OEMBED['version'] == '1.0'){
		$NFB_OEMBED['html'] = htmlspecialchars_decode($xml_file->getElementByTagName('html')); //the embed code
		$NFB_OEMBED['width'] = strip_tags($xml_file->getElementByTagName('width')); //default width
		$NFB_OEMBED['height'] = strip_tags($xml_file->getElementByTagName('height')); //default height
		$NFB_OEMBED['author_name'] = strip_tags($xml_file->getElementByTagName('author_name'));
		$NFB_OEMBED['author_url'] = strip_tags($xml_file->getElementByTagName('author_url'));
		$NFB_OEMBED['cache_age'] = strip_tags($xml_file->getElementByTagName('cache_age'));
		$NFB_OEMBED['provider_name'] = strip_tags($xml_file->getElementByTagName('provider_name'));
		$NFB_OEMBED['provider_url'] = strip_tags($xml_file->getElementByTagName('provider_url'));
		$NFB_OEMBED['thumbnail_height'] = strip_tags($xml_file->getElementByTagName('thumbnail_height'));
		$NFB_OEMBED['thumbnail_url'] = strip_tags($xml_file->getElementByTagName('thumbnail_url'));
		$NFB_OEMBED['thumbnail_width'] = strip_tags($xml_file->getElementByTagName('thumbnail_width'));
		$NFB_OEMBED['title'] = strip_tags($xml_file->getElementByTagName('title'));
		$NFB_OEMBED['nfbwidth'] = get_option('oembed_nfb_width');
		$NFB_OEMBED['nfbheight'] = get_option('oembed_nfb_height');
		//$NFB_OEMBED['url'] = (strip_tags($oembed_video_html->getElementByTagName('url')) != "" ? strip_tags($oembed_video_html->getElementByTagName('url')) : $OEMBED_URL);

		//replace old values
		//eregi_replace('/width\=[\"|\']?\d?[\"|\']?/', 'width');
		$replace_vals = array( 
			array( 'search' => 'width="'.$NFB_OEMBED['width'].'"', 'replace' => 'width="'.$NFB_OEMBED['nfbwidth'].'"'),
			array( 'search' => 'width='.$NFB_OEMBED['width'], 'replace' => 'width='.$NFB_OEMBED['nfbwidth'] ),
			array( 'search' => 'height="'.$NFB_OEMBED['height'].'"', 'replace' => 'height="'.$NFB_OEMBED['nfbheight'].'"' ),
			array( 'search' => 'height='.$NFB_OEMBED['height'], 'replace' => 'height='.$NFB_OEMBED['nfbheight'] )
		);

		foreach($replace_vals as $replacements){
			if (strstr($replacements['search'],"width") && $NFB_OEMBED['width'] != ""){
				$NFB_OEMBED['html'] = str_replace($replacements['search'], $replacements['replace'], $NFB_OEMBED['html']);
			}
			if (strstr($replacements['search'],"height") && $NFB_OEMBED['height'] != ""):
				$NFB_OEMBED['html'] = str_replace($replacements['search'], $replacements['replace'], $NFB_OEMBED['html']);
			endif;
		}
		
		//ADD THE CAPTION DETAILS
		if((get_option('oembed_nfb_video_title') == 1) || (get_option('oembed_nfb_video_author') == 1) || (get_option('oembed_nfb_video_provider') == 1)){
			$NFB_OEMBED['html'] .= "<p id=\"nfb-video-caption\">";
			//DISPLAY THE TITLE
			if (($NFB_OEMBED['title'] != "") && (get_option('oembed_nfb_video_title') == 1)):
				$NFB_OEMBED['html'] .= '<span class="nfb-video-plugin-title"><a href="'.$NFB_OEMBED['url'].'">'.$NFB_OEMBED['title'].'</a></span> ';
			endif;
			//DISPLAY THE AUTHOR NAME
			if (($NFB_OEMBED['author_name'] != "")):
				if (get_option('oembed_nfb_video_title') == 1){
					if (($NFB_OEMBED['title'] != "") && (get_option('oembed_nfb_video_title') == 1)){
						
						$NFB_OEMBED['html'] .= get_option("oembed_nfb_separator").' '.$NFB_OEMBED['author_name'];
					}
					
				}
				else {
					if (get_option('oembed_nfb_video_author') == 1){
						$NFB_OEMBED['html'] .= $NFB_OEMBED['author_name'];
					}
				}
			endif;
			//DISPLAY THE PROVIDER NAME
			if (($NFB_OEMBED['provider_name'] != "") && (get_option('oembed_nfb_video_provider') == 1)):
				if ($NFB_OEMBED['provider_url'] != ""){
					$NFB_OEMBED['html'] .= '<br /><a href="'.$NFB_OEMBED['provider_url'].'">'.$NFB_OEMBED['provider_name'].'</a>';
				}
				else {
					$NFB_OEMBED['html'] .= '<br />'.$NFB_OEMBED['provider_name'];
				}
			endif;
			$NFB_OEMBED['html'] .= "</p>";
		}

	}
	$xml_file->clear();	
}

function nfb_get_embed_code(&$text){
	global $NFB_OEMBED;
	//retrieve the links from the text
	$links = nfb_get_links($text);
	foreach($links as $link){
		if (substr($link, 0, 4)!='http'){
			$nlink = substr($link, 1,strlen($link));
		}
		else{
			$nlink = $link;
		}
		$NFB_FOUND_OEMBED = nfb_get_oembed_links($nlink);
		if(isset($NFB_OEMBED['xml_link']) && ($NFB_FOUND_OEMBED==1)){
			nfb_get_video_details();
			$text = preg_replace('/\s?'.str_replace("/","\/",$nlink).'/i', htmlspecialchars_decode($NFB_OEMBED['html']), $text);
		}
	}	
	return $text;
}

//THE ADMIN

function oEmbed_NFB_menu(){
	global $NFB_OEMBED;
	
	add_options_page('NFB Video Options', 'NFB Video Settings', 8, 'nfb_video_plugin_admin_view.php', 'oEmbed_NFB_options');
	
	if (get_option('oembed_nfb_width') == null){
		add_option('oembed_nfb_width','516','','no');
	}
	if (get_option('oembed_nfb_height') == null){
		add_option('oembed_nfb_height','337','','no');
	}
	if (get_option('oembed_nfb_video_title') == null){
		add_option('oembed_nfb_video_title', '0', '', 'no');
	}
	if (get_option('oembed_nfb_video_author') == null){
		add_option('oembed_nfb_video_author', '0', '', 'no');
	}
	if (get_option('oembed_nfb_video_provider') == null){
		add_option('oembed_nfb_video_provider', '0', '', 'no');
	}
	if (get_option('oembed_nfb_separator') == null){
		add_option('oembed_nfb_separator', ',', '', 'no');
	}
	
	//$NFB_OEMBED['nfbwidth'] = get_option('oembed_nfb_width');
	//$NFB_OEMBED['nfbheight'] = get_option('oembed_nfb_height');	
	
}

function oEmbed_NFB_options(){
	include('nfb_video_plugin_admin_view.php');

}


// execute the following filter to replace the links with embeds.
add_filter('the_content', 'nfb_get_embed_code', 1);

// The Administration parts for oEmbed_NFB
add_action('admin_menu', 'oEmbed_NFB_menu');




?>